
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef CLONE_PRINT_H
#define CLONE_PRINT_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/pomPrint.h"

#include "server/genBasicPrint.h"


#include "clonePosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern void print_struct_CLONE_SPEECH_POSTER_STR ( FILE *out,
     struct CLONE_SPEECH_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_STR ( FILE *out,
     struct CLONE_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_STEREOTYPE ( FILE *out,
     struct CLONE_STEREOTYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_CLONE_STEREOTYPE_TYPE ( FILE *out,
     enum CLONE_STEREOTYPE_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_SPEECH_OBJ ( FILE *out,
     struct CLONE_SPEECH_OBJ *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_TRACK ( FILE *out,
     struct CLONE_TRACK *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_LOOK_AT_POINT ( FILE *out,
     struct CLONE_LOOK_AT_POINT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_LOOK_AT ( FILE *out,
     struct CLONE_LOOK_AT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_CLONE_MOTION ( FILE *out,
     enum CLONE_MOTION *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_CLONE_FRAME ( FILE *out,
     enum CLONE_FRAME *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_SENTENCE ( FILE *out,
     struct CLONE_SENTENCE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_SPEECH ( FILE *out,
     struct CLONE_SPEECH *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_PLAY_FILE_PARAMS ( FILE *out,
     struct CLONE_PLAY_FILE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_WINDOW_SIZES ( FILE *out,
     struct CLONE_WINDOW_SIZES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_WINDOW_PARAMS ( FILE *out,
     struct CLONE_WINDOW_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_INIT ( FILE *out,
     struct CLONE_INIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_POS_CORR ( FILE *out,
     struct CLONE_POS_CORR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_CLONE_POS ( FILE *out,
     struct CLONE_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_CLONE_MODEL ( FILE *out,
     enum CLONE_MODEL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_CLONE_STATE ( FILE *out,
     enum CLONE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_CLONE_BOOL ( FILE *out,
     enum CLONE_BOOL *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void print_CLONE_BOOL ( FILE *out,
     CLONE_BOOL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_STATE ( FILE *out,
     CLONE_STATE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_MODEL ( FILE *out,
     CLONE_MODEL *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_POS ( FILE *out,
     CLONE_POS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_POS_CORR ( FILE *out,
     CLONE_POS_CORR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_INIT ( FILE *out,
     CLONE_INIT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_WINDOW_PARAMS ( FILE *out,
     CLONE_WINDOW_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_WINDOW_SIZES ( FILE *out,
     CLONE_WINDOW_SIZES *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_PLAY_FILE_PARAMS ( FILE *out,
     CLONE_PLAY_FILE_PARAMS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_SPEECH ( FILE *out,
     CLONE_SPEECH *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_SENTENCE ( FILE *out,
     CLONE_SENTENCE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_FRAME ( FILE *out,
     CLONE_FRAME *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_MOTION ( FILE *out,
     CLONE_MOTION *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_LOOK_AT ( FILE *out,
     CLONE_LOOK_AT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_LOOK_AT_POINT ( FILE *out,
     CLONE_LOOK_AT_POINT *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_TRACK ( FILE *out,
     CLONE_TRACK *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_SPEECH_OBJ ( FILE *out,
     CLONE_SPEECH_OBJ *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_STEREOTYPE_TYPE ( FILE *out,
     CLONE_STEREOTYPE_TYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_STEREOTYPE ( FILE *out,
     CLONE_STEREOTYPE *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_STR ( FILE *out,
     CLONE_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_CLONE_SPEECH_POSTER_STR ( FILE *out,
     CLONE_SPEECH_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
#ifdef __cplusplus
}
#endif

#endif /* CLONE_PRINT_H */

