
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef clone_TCLSERV_CLIENT_MSG_LIB_H
#define clone_TCLSERV_CLIENT_MSG_LIB_H

#include <server/cloneType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int cloneTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int cloneTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int cloneTclservClientInitRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_INIT *(in_initParams) 
		);

int cloneTclservClientInitReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientInitRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_INIT *(in_initParams) ,
				
				int *bilan);

int cloneTclservClientInitRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_INIT *(in_initParams) ,
					
					int *bilan);




int cloneTclservClientGetInitParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int cloneTclservClientGetInitParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       CLONE_INIT *(out_initParams),
			       int *bilan);

int cloneTclservClientGetInitParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 CLONE_INIT *(out_initParams),
				 int *bilan);




int cloneTclservClientPomPosOnOffRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 CLONE_BOOL *(in_pomOn)
		);

int cloneTclservClientPomPosOnOffReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int cloneTclservClientPomPosOnOffRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 CLONE_BOOL *(in_pomOn) ,
				 
				 int *bilan);




int cloneTclservClientSetHideWindowRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_BOOL *(in_hideWindow) 
		);

int cloneTclservClientSetHideWindowReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientSetHideWindowRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_BOOL *(in_hideWindow) ,
				
				int *bilan);

int cloneTclservClientSetHideWindowRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_BOOL *(in_hideWindow) ,
					
					int *bilan);




int cloneTclservClientGetHideWindowRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int cloneTclservClientGetHideWindowReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       CLONE_BOOL *(out_hideWindow),
			       int *bilan);

int cloneTclservClientGetHideWindowRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 CLONE_BOOL *(out_hideWindow),
				 int *bilan);




int cloneTclservClientSetWindowGeomRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_WINDOW_PARAMS *(in_windowParams) 
		);

int cloneTclservClientSetWindowGeomReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientSetWindowGeomRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_WINDOW_PARAMS *(in_windowParams) ,
				
				int *bilan);

int cloneTclservClientSetWindowGeomRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_WINDOW_PARAMS *(in_windowParams) ,
					
					int *bilan);




int cloneTclservClientGetWindowGeomRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int cloneTclservClientGetWindowGeomReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       CLONE_WINDOW_PARAMS *(out_windowParams),
			       int *bilan);

int cloneTclservClientGetWindowGeomRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 CLONE_WINDOW_PARAMS *(out_windowParams),
				 int *bilan);




int cloneTclservClientGetPlayFileRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int cloneTclservClientGetPlayFileReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       CLONE_PLAY_FILE_PARAMS *(out_playFileParams),
			       int *bilan);

int cloneTclservClientGetPlayFileRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 CLONE_PLAY_FILE_PARAMS *(out_playFileParams),
				 int *bilan);




int cloneTclservClientPlayFileRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_PLAY_FILE_PARAMS *(in_playFileParams) 
		);

int cloneTclservClientPlayFileReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientPlayFileRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_PLAY_FILE_PARAMS *(in_playFileParams) ,
				
				int *bilan);

int cloneTclservClientPlayFileRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_PLAY_FILE_PARAMS *(in_playFileParams) ,
					
					int *bilan);




int cloneTclservClientPlayRefRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 int *(in_playRefParams) 
		);

int cloneTclservClientPlayRefReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientPlayRefRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				int *(in_playRefParams) ,
				
				int *bilan);

int cloneTclservClientPlayRefRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					int *(in_playRefParams) ,
					
					int *bilan);




int cloneTclservClientRePlayRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int cloneTclservClientRePlayReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientRePlayRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int cloneTclservClientRePlayRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int cloneTclservClientCleanFifoRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int cloneTclservClientCleanFifoReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientCleanFifoRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int cloneTclservClientCleanFifoRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int cloneTclservClientStopPlayRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int cloneTclservClientStopPlayReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientStopPlayRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int cloneTclservClientStopPlayRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int cloneTclservClientCleanFileRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_PLAY_FILE_PARAMS *(in_playFileParams) 
		);

int cloneTclservClientCleanFileReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientCleanFileRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_PLAY_FILE_PARAMS *(in_playFileParams) ,
				
				int *bilan);

int cloneTclservClientCleanFileRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_PLAY_FILE_PARAMS *(in_playFileParams) ,
					
					int *bilan);




int cloneTclservClientExportSentenceRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_SENTENCE *(in_sentence) 
		);

int cloneTclservClientExportSentenceReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientExportSentenceRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_SENTENCE *(in_sentence) ,
				
				int *bilan);

int cloneTclservClientExportSentenceRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_SENTENCE *(in_sentence) ,
					
					int *bilan);




int cloneTclservClientStopLookRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int cloneTclservClientStopLookReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int cloneTclservClientStopLookRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int cloneTclservClientLookAtRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_LOOK_AT *(in_lookAt) 
		);

int cloneTclservClientLookAtReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientLookAtRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_LOOK_AT *(in_lookAt) ,
				
				int *bilan);

int cloneTclservClientLookAtRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_LOOK_AT *(in_lookAt) ,
					
					int *bilan);




int cloneTclservClientHeadLookAtRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_LOOK_AT_POINT *(in_headLookAt) 
		);

int cloneTclservClientHeadLookAtReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientHeadLookAtRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_LOOK_AT_POINT *(in_headLookAt) ,
				
				int *bilan);

int cloneTclservClientHeadLookAtRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_LOOK_AT_POINT *(in_headLookAt) ,
					
					int *bilan);




int cloneTclservClientEyesLookAtRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_LOOK_AT_POINT *(in_eyesLookAt) 
		);

int cloneTclservClientEyesLookAtReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientEyesLookAtRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_LOOK_AT_POINT *(in_eyesLookAt) ,
				
				int *bilan);

int cloneTclservClientEyesLookAtRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_LOOK_AT_POINT *(in_eyesLookAt) ,
					
					int *bilan);




int cloneTclservClientHeadAndEyesLookAtRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_LOOK_AT_POINT *(in_headAndEyesLookAt) 
		);

int cloneTclservClientHeadAndEyesLookAtReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientHeadAndEyesLookAtRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_LOOK_AT_POINT *(in_headAndEyesLookAt) ,
				
				int *bilan);

int cloneTclservClientHeadAndEyesLookAtRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_LOOK_AT_POINT *(in_headAndEyesLookAt) ,
					
					int *bilan);




int cloneTclservClientStereotypeMotionRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_STEREOTYPE *(in_stereotype) 
		);

int cloneTclservClientStereotypeMotionReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientStereotypeMotionRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_STEREOTYPE *(in_stereotype) ,
				
				int *bilan);

int cloneTclservClientStereotypeMotionRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_STEREOTYPE *(in_stereotype) ,
					
					int *bilan);




int cloneTclservClientLookAtSpeechObjsRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int cloneTclservClientLookAtSpeechObjsReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientLookAtSpeechObjsRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int cloneTclservClientLookAtSpeechObjsRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int cloneTclservClientAddSpeechObjRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 CLONE_SPEECH_OBJ *(in_speechObj) 
		);

int cloneTclservClientAddSpeechObjReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientAddSpeechObjRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				CLONE_SPEECH_OBJ *(in_speechObj) ,
				
				int *bilan);

int cloneTclservClientAddSpeechObjRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					CLONE_SPEECH_OBJ *(in_speechObj) ,
					
					int *bilan);




int cloneTclservClientRemoveSpeechObjRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING256 *(in_speechObjName) 
		);

int cloneTclservClientRemoveSpeechObjReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int cloneTclservClientRemoveSpeechObjRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING256 *(in_speechObjName) ,
				
				int *bilan);

int cloneTclservClientRemoveSpeechObjRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING256 *(in_speechObjName) ,
					
					int *bilan);




int cloneTclservClientSetLookCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 CLONE_POS_CORR *(in_lookCorrection)
		);

int cloneTclservClientSetLookCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int cloneTclservClientSetLookCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 CLONE_POS_CORR *(in_lookCorrection) ,
				 
				 int *bilan);




int cloneTclservClientGetLookCorrectionRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int cloneTclservClientGetLookCorrectionReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       CLONE_POS_CORR *(out_lookCorrection),
			       int *bilan);

int cloneTclservClientGetLookCorrectionRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 CLONE_POS_CORR *(out_lookCorrection),
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* cloneTCLSERV_CLIENT_MSG_LIB_H */

