
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] cloneInstall] >= 0 } {
    interp expose {} cloneInstall
}

proc ::cloneInstall { name } {
    foreach rqst { "Init" "GetInitParams" "PomPosOnOff" "SetHideWindow" "GetHideWindow" "SetWindowGeom" "GetWindowGeom" "GetPlayFile" "PlayFile" "PlayRef" "RePlay" "CleanFifo" "StopPlay" "CleanFile" "ExportSentence" "StopLook" "LookAt" "HeadLookAt" "EyesLookAt" "HeadAndEyesLookAt" "StereotypeMotion" "LookAtSpeechObjs" "AddSpeechObj" "RemoveSpeechObj" "SetLookCorrection" "GetLookCorrection" "SpeechSpeechPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} clone$rqst $name
    }
}

interp hide {} cloneInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] cloneInit] >= 0 } {
    interp expose {} cloneInit
}
if { [lsearch [interp hidden] cloneInitFormatOutput] >= 0 } {
    interp expose {} cloneInitFormatOutput
}

proc ::cloneInit { name args } {
    set format {}
    lappend format [list { "CLONE_MODEL_YASMINE_LPC" "CLONE_MODEL_YASMINE" "CLONE_MODEL_SASHA" "CLONE_MODEL_PIERRE" "CLONE_MODEL_HELENE" } "A clone" "CLONE_MODEL_HELENE" ]
    lappend format [list { "CLONE_FALSE" "CLONE_TRUE" } "Pom tagging on or off" "CLONE_FALSE" ]
    lappend format [list string "DISPLAY" "city:0.0" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Init clone" \
	"CLONE_INIT\n| CLONE_MODEL model\n| CLONE_BOOL pomOn\n| char displayEnv\[256\]\n" \
	3 \
	$format \
	$args ]
}


proc ::cloneInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneInit
interp hide {} cloneInitFormatOutput





# GetInitParams ----------------------------------------------------------

if { [lsearch [interp hidden] cloneGetInitParams] >= 0 } {
    interp expose {} cloneGetInitParams
}
if { [lsearch [interp hidden] cloneGetInitParamsFormatOutput] >= 0 } {
    interp expose {} cloneGetInitParamsFormatOutput
}

proc ::cloneGetInitParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetInitParams" \
	"current clone model" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneGetInitParamsFormatOutput { list } {
    set format { {} status { } { initParams { } model { } pomOn { } displayEnv } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneGetInitParams
interp hide {} cloneGetInitParamsFormatOutput





# PomPosOnOff ----------------------------------------------------------

if { [lsearch [interp hidden] clonePomPosOnOff] >= 0 } {
    interp expose {} clonePomPosOnOff
}
if { [lsearch [interp hidden] clonePomPosOnOffFormatOutput] >= 0 } {
    interp expose {} clonePomPosOnOffFormatOutput
}

proc ::clonePomPosOnOff { name args } {
    set format {}
    lappend format [list { "CLONE_FALSE" "CLONE_TRUE" } "pomOn" "" ]

    return [ ::cs::rqstSend "${name}" "PomPosOnOff" \
	"<some doc>" \
	"CLONE_BOOL pomOn\n" \
	1 \
	$format \
	$args ]
}


proc ::clonePomPosOnOffFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} clonePomPosOnOff
interp hide {} clonePomPosOnOffFormatOutput





# SetHideWindow ----------------------------------------------------------

if { [lsearch [interp hidden] cloneSetHideWindow] >= 0 } {
    interp expose {} cloneSetHideWindow
}
if { [lsearch [interp hidden] cloneSetHideWindowFormatOutput] >= 0 } {
    interp expose {} cloneSetHideWindowFormatOutput
}

proc ::cloneSetHideWindow { name args } {
    set format {}
    lappend format [list { "CLONE_FALSE" "CLONE_TRUE" } "hideWindow" "" ]

    return [ ::cs::rqstSend "${name}" "SetHideWindow" \
	"Hide or show window" \
	"CLONE_BOOL hideWindow\n" \
	1 \
	$format \
	$args ]
}


proc ::cloneSetHideWindowFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneSetHideWindow
interp hide {} cloneSetHideWindowFormatOutput





# GetHideWindow ----------------------------------------------------------

if { [lsearch [interp hidden] cloneGetHideWindow] >= 0 } {
    interp expose {} cloneGetHideWindow
}
if { [lsearch [interp hidden] cloneGetHideWindowFormatOutput] >= 0 } {
    interp expose {} cloneGetHideWindowFormatOutput
}

proc ::cloneGetHideWindow { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetHideWindow" \
	"Window state (hide/show)" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneGetHideWindowFormatOutput { list } {
    set format { {} status { } hideWindow }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneGetHideWindow
interp hide {} cloneGetHideWindowFormatOutput





# SetWindowGeom ----------------------------------------------------------

if { [lsearch [interp hidden] cloneSetWindowGeom] >= 0 } {
    interp expose {} cloneSetWindowGeom
}
if { [lsearch [interp hidden] cloneSetWindowGeomFormatOutput] >= 0 } {
    interp expose {} cloneSetWindowGeomFormatOutput
}

proc ::cloneSetWindowGeom { name args } {
    set format {}
    lappend format [list double "windowParams.scale" 0.0 ]
    lappend format [list double "windowParams.x" 0.0 ]
    lappend format [list double "windowParams.y" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetWindowGeom" \
	"Set window size and position" \
	"CLONE_WINDOW_PARAMS\n| double scale\n| double x\n| double y\n" \
	3 \
	$format \
	$args ]
}


proc ::cloneSetWindowGeomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneSetWindowGeom
interp hide {} cloneSetWindowGeomFormatOutput





# GetWindowGeom ----------------------------------------------------------

if { [lsearch [interp hidden] cloneGetWindowGeom] >= 0 } {
    interp expose {} cloneGetWindowGeom
}
if { [lsearch [interp hidden] cloneGetWindowGeomFormatOutput] >= 0 } {
    interp expose {} cloneGetWindowGeomFormatOutput
}

proc ::cloneGetWindowGeom { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetWindowGeom" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneGetWindowGeomFormatOutput { list } {
    set format { {} status { } { windowParams { } scale { } x { } y } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneGetWindowGeom
interp hide {} cloneGetWindowGeomFormatOutput





# GetPlayFile ----------------------------------------------------------

if { [lsearch [interp hidden] cloneGetPlayFile] >= 0 } {
    interp expose {} cloneGetPlayFile
}
if { [lsearch [interp hidden] cloneGetPlayFileFormatOutput] >= 0 } {
    interp expose {} cloneGetPlayFileFormatOutput
}

proc ::cloneGetPlayFile { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetPlayFile" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneGetPlayFileFormatOutput { list } {
    set format { {} status { } { playFileParams { } txtFile { } synFiles } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneGetPlayFile
interp hide {} cloneGetPlayFileFormatOutput





# PlayFile ----------------------------------------------------------

if { [lsearch [interp hidden] clonePlayFile] >= 0 } {
    interp expose {} clonePlayFile
}
if { [lsearch [interp hidden] clonePlayFileFormatOutput] >= 0 } {
    interp expose {} clonePlayFileFormatOutput
}

proc ::clonePlayFile { name args } {
    set format {}
    lappend format [list string "playFileParams.txtFile" "" ]
    lappend format [list string "playFileParams.synFiles" "" ]

    return [ ::cs::rqstSend "${name}" "PlayFile" \
	"To make the clone speak using given file" \
	"CLONE_PLAY_FILE_PARAMS\n| char txtFile\[256\]\n| char synFiles\[256\]\n" \
	2 \
	$format \
	$args ]
}


proc ::clonePlayFileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} clonePlayFile
interp hide {} clonePlayFileFormatOutput





# PlayRef ----------------------------------------------------------

if { [lsearch [interp hidden] clonePlayRef] >= 0 } {
    interp expose {} clonePlayRef
}
if { [lsearch [interp hidden] clonePlayRefFormatOutput] >= 0 } {
    interp expose {} clonePlayRefFormatOutput
}

proc ::clonePlayRef { name args } {
    set format {}
    lappend format [list int "playRefParams" 0 ]

    return [ ::cs::rqstSend "${name}" "PlayRef" \
	"To make the clone speak using given ref" \
	"int playRefParams\n" \
	1 \
	$format \
	$args ]
}


proc ::clonePlayRefFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} clonePlayRef
interp hide {} clonePlayRefFormatOutput





# RePlay ----------------------------------------------------------

if { [lsearch [interp hidden] cloneRePlay] >= 0 } {
    interp expose {} cloneRePlay
}
if { [lsearch [interp hidden] cloneRePlayFormatOutput] >= 0 } {
    interp expose {} cloneRePlayFormatOutput
}

proc ::cloneRePlay { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "RePlay" \
	"To make the clone speak using given ref" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneRePlayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneRePlay
interp hide {} cloneRePlayFormatOutput





# CleanFifo ----------------------------------------------------------

if { [lsearch [interp hidden] cloneCleanFifo] >= 0 } {
    interp expose {} cloneCleanFifo
}
if { [lsearch [interp hidden] cloneCleanFifoFormatOutput] >= 0 } {
    interp expose {} cloneCleanFifoFormatOutput
}

proc ::cloneCleanFifo { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "CleanFifo" \
	"Clean waiting messages" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneCleanFifoFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneCleanFifo
interp hide {} cloneCleanFifoFormatOutput





# StopPlay ----------------------------------------------------------

if { [lsearch [interp hidden] cloneStopPlay] >= 0 } {
    interp expose {} cloneStopPlay
}
if { [lsearch [interp hidden] cloneStopPlayFormatOutput] >= 0 } {
    interp expose {} cloneStopPlayFormatOutput
}

proc ::cloneStopPlay { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopPlay" \
	"Stop clone speak" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneStopPlayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneStopPlay
interp hide {} cloneStopPlayFormatOutput





# CleanFile ----------------------------------------------------------

if { [lsearch [interp hidden] cloneCleanFile] >= 0 } {
    interp expose {} cloneCleanFile
}
if { [lsearch [interp hidden] cloneCleanFileFormatOutput] >= 0 } {
    interp expose {} cloneCleanFileFormatOutput
}

proc ::cloneCleanFile { name args } {
    set format {}
    lappend format [list string "playFileParams.txtFile" "" ]
    lappend format [list string "playFileParams.synFiles" "" ]

    return [ ::cs::rqstSend "${name}" "CleanFile" \
	"Clean files" \
	"CLONE_PLAY_FILE_PARAMS\n| char txtFile\[256\]\n| char synFiles\[256\]\n" \
	2 \
	$format \
	$args ]
}


proc ::cloneCleanFileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneCleanFile
interp hide {} cloneCleanFileFormatOutput





# ExportSentence ----------------------------------------------------------

if { [lsearch [interp hidden] cloneExportSentence] >= 0 } {
    interp expose {} cloneExportSentence
}
if { [lsearch [interp hidden] cloneExportSentenceFormatOutput] >= 0 } {
    interp expose {} cloneExportSentenceFormatOutput
}

proc ::cloneExportSentence { name args } {
    set format {}
    lappend format [list string "sentence.french" "" ]
    lappend format [list string "sentence.english" "" ]

    return [ ::cs::rqstSend "${name}" "ExportSentence" \
	"<some doc>" \
	"CLONE_SENTENCE\n| char french\[1024\]\n| char english\[1024\]\n" \
	2 \
	$format \
	$args ]
}


proc ::cloneExportSentenceFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneExportSentence
interp hide {} cloneExportSentenceFormatOutput





# StopLook ----------------------------------------------------------

if { [lsearch [interp hidden] cloneStopLook] >= 0 } {
    interp expose {} cloneStopLook
}
if { [lsearch [interp hidden] cloneStopLookFormatOutput] >= 0 } {
    interp expose {} cloneStopLookFormatOutput
}

proc ::cloneStopLook { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLook" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneStopLookFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneStopLook
interp hide {} cloneStopLookFormatOutput





# LookAt ----------------------------------------------------------

if { [lsearch [interp hidden] cloneLookAt] >= 0 } {
    interp expose {} cloneLookAt
}
if { [lsearch [interp hidden] cloneLookAtFormatOutput] >= 0 } {
    interp expose {} cloneLookAtFormatOutput
}

proc ::cloneLookAt { name args } {
    set format {}
    lappend format [list { "CLONE_MOVES_BOTH" "CLONE_MOVES_EYES" "CLONE_MOVES_HEAD" } "lookAt.motion" "" ]
    lappend format [list { "CLONE_WORLD_FRAME" "CLONE_ROBOT_FRAME" "CLONE_CLONE_FRAME" } "lookAt.frame" "" ]
    lappend format [list double "lookAt.pos.x" 0.0 ]
    lappend format [list double "lookAt.pos.y" 0.0 ]
    lappend format [list double "lookAt.pos.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "LookAt" \
	"<some doc>" \
	"CLONE_LOOK_AT\n| CLONE_MOTION motion\n| CLONE_FRAME frame\n| CLONE_POS\n| | double x\n| | double y\n| | double z\n" \
	5 \
	$format \
	$args ]
}


proc ::cloneLookAtFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneLookAt
interp hide {} cloneLookAtFormatOutput





# HeadLookAt ----------------------------------------------------------

if { [lsearch [interp hidden] cloneHeadLookAt] >= 0 } {
    interp expose {} cloneHeadLookAt
}
if { [lsearch [interp hidden] cloneHeadLookAtFormatOutput] >= 0 } {
    interp expose {} cloneHeadLookAtFormatOutput
}

proc ::cloneHeadLookAt { name args } {
    set format {}
    lappend format [list { "CLONE_WORLD_FRAME" "CLONE_ROBOT_FRAME" "CLONE_CLONE_FRAME" } "headLookAt.frame" "" ]
    lappend format [list int "headLookAt.unused" 0 ]
    lappend format [list double "headLookAt.pos.x" 0.0 ]
    lappend format [list double "headLookAt.pos.y" 0.0 ]
    lappend format [list double "headLookAt.pos.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "HeadLookAt" \
	"<some doc>" \
	"CLONE_LOOK_AT_POINT\n| CLONE_FRAME frame\n| int unused\n| CLONE_POS\n| | double x\n| | double y\n| | double z\n" \
	5 \
	$format \
	$args ]
}


proc ::cloneHeadLookAtFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneHeadLookAt
interp hide {} cloneHeadLookAtFormatOutput





# EyesLookAt ----------------------------------------------------------

if { [lsearch [interp hidden] cloneEyesLookAt] >= 0 } {
    interp expose {} cloneEyesLookAt
}
if { [lsearch [interp hidden] cloneEyesLookAtFormatOutput] >= 0 } {
    interp expose {} cloneEyesLookAtFormatOutput
}

proc ::cloneEyesLookAt { name args } {
    set format {}
    lappend format [list { "CLONE_WORLD_FRAME" "CLONE_ROBOT_FRAME" "CLONE_CLONE_FRAME" } "eyesLookAt.frame" "" ]
    lappend format [list int "eyesLookAt.unused" 0 ]
    lappend format [list double "eyesLookAt.pos.x" 0.0 ]
    lappend format [list double "eyesLookAt.pos.y" 0.0 ]
    lappend format [list double "eyesLookAt.pos.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "EyesLookAt" \
	"<some doc>" \
	"CLONE_LOOK_AT_POINT\n| CLONE_FRAME frame\n| int unused\n| CLONE_POS\n| | double x\n| | double y\n| | double z\n" \
	5 \
	$format \
	$args ]
}


proc ::cloneEyesLookAtFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneEyesLookAt
interp hide {} cloneEyesLookAtFormatOutput





# HeadAndEyesLookAt ----------------------------------------------------------

if { [lsearch [interp hidden] cloneHeadAndEyesLookAt] >= 0 } {
    interp expose {} cloneHeadAndEyesLookAt
}
if { [lsearch [interp hidden] cloneHeadAndEyesLookAtFormatOutput] >= 0 } {
    interp expose {} cloneHeadAndEyesLookAtFormatOutput
}

proc ::cloneHeadAndEyesLookAt { name args } {
    set format {}
    lappend format [list { "CLONE_WORLD_FRAME" "CLONE_ROBOT_FRAME" "CLONE_CLONE_FRAME" } "headAndEyesLookAt.frame" "" ]
    lappend format [list int "headAndEyesLookAt.unused" 0 ]
    lappend format [list double "headAndEyesLookAt.pos.x" 0.0 ]
    lappend format [list double "headAndEyesLookAt.pos.y" 0.0 ]
    lappend format [list double "headAndEyesLookAt.pos.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "HeadAndEyesLookAt" \
	"<some doc>" \
	"CLONE_LOOK_AT_POINT\n| CLONE_FRAME frame\n| int unused\n| CLONE_POS\n| | double x\n| | double y\n| | double z\n" \
	5 \
	$format \
	$args ]
}


proc ::cloneHeadAndEyesLookAtFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneHeadAndEyesLookAt
interp hide {} cloneHeadAndEyesLookAtFormatOutput





# StereotypeMotion ----------------------------------------------------------

if { [lsearch [interp hidden] cloneStereotypeMotion] >= 0 } {
    interp expose {} cloneStereotypeMotion
}
if { [lsearch [interp hidden] cloneStereotypeMotionFormatOutput] >= 0 } {
    interp expose {} cloneStereotypeMotionFormatOutput
}

proc ::cloneStereotypeMotion { name args } {
    set format {}
    lappend format [list { "CLONE_STEREOTYPE_WHEREAREYOU" "CLONE_STEREOTYPE_NO" "CLONE_STEREOTYPE_YES" } "stereotype.type" "" ]
    lappend format [list int "stereotype.nbIter" 0 ]
    lappend format [list double "stereotype.length" 0.0 ]

    return [ ::cs::rqstSend "${name}" "StereotypeMotion" \
	"<some doc>" \
	"CLONE_STEREOTYPE\n| CLONE_STEREOTYPE_TYPE type\n| int nbIter\n| double length\n" \
	3 \
	$format \
	$args ]
}


proc ::cloneStereotypeMotionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneStereotypeMotion
interp hide {} cloneStereotypeMotionFormatOutput





# LookAtSpeechObjs ----------------------------------------------------------

if { [lsearch [interp hidden] cloneLookAtSpeechObjs] >= 0 } {
    interp expose {} cloneLookAtSpeechObjs
}
if { [lsearch [interp hidden] cloneLookAtSpeechObjsFormatOutput] >= 0 } {
    interp expose {} cloneLookAtSpeechObjsFormatOutput
}

proc ::cloneLookAtSpeechObjs { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "LookAtSpeechObjs" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneLookAtSpeechObjsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneLookAtSpeechObjs
interp hide {} cloneLookAtSpeechObjsFormatOutput





# AddSpeechObj ----------------------------------------------------------

if { [lsearch [interp hidden] cloneAddSpeechObj] >= 0 } {
    interp expose {} cloneAddSpeechObj
}
if { [lsearch [interp hidden] cloneAddSpeechObjFormatOutput] >= 0 } {
    interp expose {} cloneAddSpeechObjFormatOutput
}

proc ::cloneAddSpeechObj { name args } {
    set format {}
    lappend format [list string "speechObj.name" "" ]
    lappend format [list double "speechObj.pos.x" 0.0 ]
    lappend format [list double "speechObj.pos.y" 0.0 ]
    lappend format [list double "speechObj.pos.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "AddSpeechObj" \
	"<some doc>" \
	"CLONE_SPEECH_OBJ\n| char name\[256\]\n| CLONE_POS\n| | double x\n| | double y\n| | double z\n" \
	4 \
	$format \
	$args ]
}


proc ::cloneAddSpeechObjFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneAddSpeechObj
interp hide {} cloneAddSpeechObjFormatOutput





# RemoveSpeechObj ----------------------------------------------------------

if { [lsearch [interp hidden] cloneRemoveSpeechObj] >= 0 } {
    interp expose {} cloneRemoveSpeechObj
}
if { [lsearch [interp hidden] cloneRemoveSpeechObjFormatOutput] >= 0 } {
    interp expose {} cloneRemoveSpeechObjFormatOutput
}

proc ::cloneRemoveSpeechObj { name args } {
    set format {}
    lappend format [list string "speechObjName.name" "" ]

    return [ ::cs::rqstSend "${name}" "RemoveSpeechObj" \
	"<some doc>" \
	"GEN_STRING256\n| char name\[256\]\n" \
	1 \
	$format \
	$args ]
}


proc ::cloneRemoveSpeechObjFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneRemoveSpeechObj
interp hide {} cloneRemoveSpeechObjFormatOutput





# SetLookCorrection ----------------------------------------------------------

if { [lsearch [interp hidden] cloneSetLookCorrection] >= 0 } {
    interp expose {} cloneSetLookCorrection
}
if { [lsearch [interp hidden] cloneSetLookCorrectionFormatOutput] >= 0 } {
    interp expose {} cloneSetLookCorrectionFormatOutput
}

proc ::cloneSetLookCorrection { name args } {
    set format {}
    lappend format [list double "lookCorrection.rz" 0.0 ]
    lappend format [list double "lookCorrection.ry" 0.0 ]
    lappend format [list double "lookCorrection.rx" 0.0 ]
    lappend format [list double "lookCorrection.x" 0.0 ]
    lappend format [list double "lookCorrection.y" 0.0 ]
    lappend format [list double "lookCorrection.z" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetLookCorrection" \
	"<some doc>" \
	"CLONE_POS_CORR\n| double rz\n| double ry\n| double rx\n| double x\n| double y\n| double z\n" \
	6 \
	$format \
	$args ]
}


proc ::cloneSetLookCorrectionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneSetLookCorrection
interp hide {} cloneSetLookCorrectionFormatOutput





# GetLookCorrection ----------------------------------------------------------

if { [lsearch [interp hidden] cloneGetLookCorrection] >= 0 } {
    interp expose {} cloneGetLookCorrection
}
if { [lsearch [interp hidden] cloneGetLookCorrectionFormatOutput] >= 0 } {
    interp expose {} cloneGetLookCorrectionFormatOutput
}

proc ::cloneGetLookCorrection { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetLookCorrection" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::cloneGetLookCorrectionFormatOutput { list } {
    set format { {} status { } { lookCorrection { } rz { } ry { } rx { } x { } y { } z } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneGetLookCorrection
interp hide {} cloneGetLookCorrectionFormatOutput





# SpeechSpeech ----------------------------------------------------------

if { [lsearch [interp hidden] cloneSpeechSpeechPosterRead] >= 0 } {
    interp expose {} cloneSpeechSpeechPosterRead
}
if { [lsearch [interp hidden] cloneSpeechSpeechPosterFormatOutput] >= 0 } {
    interp expose {} cloneSpeechSpeechPosterFormatOutput
}

proc ::cloneSpeechSpeechPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SpeechSpeech" \
	"CLONE_SPEECH\n| int id\n| int unused\n| char french\[1024\]\n| char english\[1024\]\n" \
	$args ]
}


proc ::cloneSpeechSpeechPosterFormatOutput { list } {
    set format { {} status { } { Speech { } id { } unused { } french { } english } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} cloneSpeechSpeechPosterRead
interp hide {} cloneSpeechSpeechPosterFormatOutput


